'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _startsWith2 = require('lodash/startsWith');

var _startsWith3 = _interopRequireDefault(_startsWith2);

var _some2 = require('lodash/some');

var _some3 = _interopRequireDefault(_some2);

var _pullAt2 = require('lodash/pullAt');

var _pullAt3 = _interopRequireDefault(_pullAt2);

var _concat2 = require('lodash/concat');

var _concat3 = _interopRequireDefault(_concat2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createRef = require('create-react-ref/lib/createRef');

var _createRef2 = _interopRequireDefault(_createRef);

var _withTheme = require('../themes/withTheme');

var _utils = require('../utils');

var _API = require('../themes/API');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// external libraries


// internal utility functions


var Autocomplete = function (_Component) {
  _inherits(Autocomplete, _Component);

  function Autocomplete(props) {
    _classCallCheck(this, Autocomplete);

    // define refs
    var _this = _possibleConstructorReturn(this, (Autocomplete.__proto__ || Object.getPrototypeOf(Autocomplete)).call(this, props));

    _initialiseProps.call(_this);

    _this.rootElement = (0, _createRef2.default)();
    _this.inputElement = (0, _createRef2.default)();
    _this.suggestionsElement = (0, _createRef2.default)();

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides,
        sortAlphabetically = props.sortAlphabetically,
        options = props.options,
        preselectedOptions = props.preselectedOptions;


    _this.state = {
      inputValue: '',
      error: '',
      selectedOptions: preselectedOptions || [],
      filteredOptions: sortAlphabetically && options ? options.sort() : options || [],
      isOpen: false,
      composedTheme: (0, _utils.composeTheme)((0, _utils.addThemeId)(theme || context.theme, themeId), (0, _utils.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  // checks for backspace in order to delete the last selected option


  // onChange handler for input element in AutocompleteSkin


  // passed to Options onChange handler in AutocompleteSkin


  // returns an object containing props, theme, and method handlers
  // associated with rendering this.state.selectedOptions, the user can call
  // this in the body of the renderSelections function


  _createClass(Autocomplete, [{
    key: 'render',
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _props = this.props,
          context = _props.context,
          invalidCharsRegex = _props.invalidCharsRegex,
          multipleSameSelections = _props.multipleSameSelections,
          sortAlphabetically = _props.sortAlphabetically,
          AutocompleteSkin = _props.skin,
          theme = _props.theme,
          themeOverrides = _props.themeOverrides,
          onChange = _props.onChange,
          error = _props.error,
          rest = _objectWithoutProperties(_props, ['context', 'invalidCharsRegex', 'multipleSameSelections', 'sortAlphabetically', 'skin', 'theme', 'themeOverrides', 'onChange', 'error']);

      return _react2.default.createElement(AutocompleteSkin, _extends({
        inputValue: this.state.inputValue,
        selectedOptions: this.state.selectedOptions,
        filteredOptions: this.state.filteredOptions,
        isOpen: this.state.isOpen,
        theme: this.state.composedTheme,
        handleInputChange: this.handleInputChange,
        error: error || this.state.error,
        rootRef: this.rootElement,
        inputRef: this.inputElement,
        suggestionsRef: this.suggestionsElement,
        handleChange: this.handleChange,
        closeOptions: this.closeOptions,
        handleAutocompleteClick: this.handleAutocompleteClick,
        removeOption: this.removeOption,
        onKeyDown: this.onKeyDown,
        getSelectionProps: this.getSelectionProps
      }, rest));
    }

    // ======== PRIVATE METHOD ==========

  }]);

  return Autocomplete;
}(_react.Component);

Autocomplete.defaultProps = {
  error: null,
  invalidCharsRegex: /[^a-zA-Z0-9]/g, // only allow letters and numbers by default
  isOpeningUpward: false,
  maxVisibleOptions: 10, // max number of visible options
  multipleSameSelections: true, // if true then same word can be selected multiple times
  options: [],
  sortAlphabetically: true, // options are sorted alphabetically by default
  theme: null,
  themeId: _API.IDENTIFIERS.AUTOCOMPLETE,
  themeOverrides: {}
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.clear = function () {
    return _this2._removeOptions();
  };

  this.focus = function () {
    return _this2.handleAutocompleteClick();
  };

  this.openOptions = function () {
    _this2.setState({ isOpen: true });
  };

  this.closeOptions = function () {
    _this2.setState({ isOpen: false });
  };

  this.handleAutocompleteClick = function () {
    var inputElement = _this2.inputElement;

    if (inputElement && inputElement.current) {
      inputElement.current.focus();
    }

    if (!_this2.state.isOpen) {
      _this2.openOptions();
    } else {
      _this2.closeOptions();
    }
  };

  this.onKeyDown = function (event) {
    if (event.keyCode === 8 && !event.target.value && _this2.state.selectedOptions.length) {
      // Remove last selected option
      _this2.removeOption(_this2.state.selectedOptions.length - 1, event);
    }
  };

  this.handleInputChange = function (event) {
    var value = event.target.value;

    // filter out invalid characters
    var filteredValue = _this2._filterInvalidChars(value);

    // filter options
    var filteredOptions = _this2._filterOptions(filteredValue);

    // open options, update filteredOptions, and update inputValue
    _this2.setState({
      isOpen: true,
      inputValue: filteredValue,
      filteredOptions: filteredOptions
    });
  };

  this.handleChange = function (option, event) {
    _this2.updateSelectedOptions(event, option);
  };

  this.updateSelectedOptions = function (event) {
    var selectedOption = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

    var canMoreOptionsBeSelected = _this2.state.selectedOptions.length < _this2.props.maxSelections;
    var areFilteredOptionsAvailable = _this2.state.filteredOptions && _this2.state.filteredOptions.length > 0;

    if (!_this2.props.maxSelections || canMoreOptionsBeSelected && areFilteredOptionsAvailable) {
      if (!selectedOption) return;
      var option = selectedOption.trim();
      var optionCanBeSelected = _this2.state.selectedOptions.indexOf(option) < 0 && !_this2.props.multipleSameSelections || _this2.props.multipleSameSelections;

      if (option && optionCanBeSelected && _this2.state.isOpen) {
        var _selectedOptions = (0, _concat3.default)(_this2.state.selectedOptions, option);
        _this2.selectionChanged(_selectedOptions, event);
        _this2.setState({ selectedOptions: _selectedOptions, isOpen: false });
      }
    }

    _this2.setState({ inputValue: '' });
  };

  this.removeOption = function (index, event) {
    var selectedOptions = _this2.state.selectedOptions;
    (0, _pullAt3.default)(selectedOptions, index);
    _this2.selectionChanged(selectedOptions, event);
    _this2.setState({ selectedOptions: selectedOptions });
  };

  this.selectionChanged = function (selectedOptions, event) {
    if (_this2.props.onChange) _this2.props.onChange(selectedOptions, event);
  };

  this.getSelectionProps = function () {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _removeSelection = _ref.removeSelection;

    var themeId = _this2.props.themeId;
    var _state = _this2.state,
        inputValue = _state.inputValue,
        isOpen = _state.isOpen,
        selectedOptions = _state.selectedOptions,
        composedTheme = _state.composedTheme;

    return {
      inputValue: inputValue,
      isOpen: isOpen,
      selectedOptions: selectedOptions,
      theme: composedTheme[themeId],
      removeSelection: function removeSelection(index, event
      // the user's custom removeSelection event handler is composed with
      // the internal functionality of Autocomplete (this.removeOption)
      ) {
        return (0, _utils.composeFunctions)(_removeSelection, _this2.removeOption)(index, event);
      }
    };
  };

  this._removeOptions = function () {
    var onChange = _this2.props.onChange;

    onChange ? onChange([]) : null;
    _this2.setState({ selectedOptions: [], inputValue: '' });
  };

  this._filterOptions = function (value) {
    var filteredOptions = [];

    if (value !== '') {
      (0, _some3.default)(_this2.props.options, function (option) {
        if ((0, _startsWith3.default)(option, value)) {
          filteredOptions.push(option);
        }
      });
    } else {
      filteredOptions = _this2.props.options;
    }

    return filteredOptions;
  };

  this._filterInvalidChars = function (value) {
    var filteredValue = '';

    if (_this2.props.invalidCharsRegex.test(value)) {
      filteredValue = value.replace(_this2.props.invalidCharsRegex, '');
    } else {
      filteredValue = value;
    }

    return filteredValue;
  };
};

exports.default = (0, _withTheme.withTheme)(Autocomplete);
//# sourceMappingURL=Autocomplete.js.map