'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormField = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withTheme = require('../themes/withTheme');

var _utils = require('../utils');

var _API = require('../themes/API');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// internal utility functions


// import constants


var FormField = exports.FormField = function (_Component) {
  _inherits(FormField, _Component);

  function FormField(props) {
    _classCallCheck(this, FormField);

    var _this = _possibleConstructorReturn(this, (FormField.__proto__ || Object.getPrototypeOf(FormField)).call(this, props));

    _this.setError = function (error) {
      return _this.setState({ error: error });
    };

    _this.focusChild = function () {
      if (_this.child && _this.child.focus !== undefined) {
        _this.child.focus();
      }
    };

    _this.onRef = function (ref) {
      return _this.child = ref;
    };

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;


    _this.state = {
      error: '',
      composedTheme: (0, _utils.composeTheme)((0, _utils.addThemeId)(theme || context.theme, themeId), (0, _utils.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  // onRef is passed to Input/NumericInput components rendered
  // via this.props.render, which makes this.focusChild possible


  _createClass(FormField, [{
    key: 'render',
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _props = this.props,
          FormFieldSkin = _props.skin,
          theme = _props.theme,
          themeOverrides = _props.themeOverrides,
          error = _props.error,
          context = _props.context,
          rest = _objectWithoutProperties(_props, ['skin', 'theme', 'themeOverrides', 'error', 'context']);

      return _react2.default.createElement(FormFieldSkin, _extends({
        error: error || this.state.error,
        setError: this.setError,
        theme: this.state.composedTheme,
        focusChild: this.focusChild,
        onRef: this.onRef
      }, rest));
    }
  }]);

  return FormField;
}(_react.Component);

FormField.defaultProps = {
  disabled: false,
  theme: null,
  themeId: _API.IDENTIFIERS.FORM_FIELD,
  themeOverrides: {}
};
exports.default = (0, _withTheme.withTheme)(FormField);
//# sourceMappingURL=FormField.js.map