'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createRef = require('create-react-ref/lib/createRef');

var _createRef2 = _interopRequireDefault(_createRef);

var _withTheme = require('../themes/withTheme');

var _utils = require('../utils');

var _API = require('../themes/API');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// internal utility functions


// import constants


var Select = function (_Component) {
  _inherits(Select, _Component);

  function Select(props) {
    _classCallCheck(this, Select);

    // define ref
    var _this = _possibleConstructorReturn(this, (Select.__proto__ || Object.getPrototypeOf(Select)).call(this, props));

    _this.focus = function () {
      return _this.toggleOpen();
    };

    _this.toggleOpen = function () {
      _this.setState({ isOpen: !_this.state.isOpen });
    };

    _this.handleInputClick = function (event) {
      event.stopPropagation();
      event.preventDefault();

      var inputElement = _this.inputElement;

      if (inputElement && inputElement.current) {
        inputElement.current.blur();
      }
      _this.toggleOpen();
    };

    _this.handleChange = function (option, event) {
      if (_this.props.onChange) _this.props.onChange(option.value, event);
      _this.toggleOpen();
    };

    _this.getSelectedOption = function () {
      var _this$props = _this.props,
          options = _this$props.options,
          value = _this$props.value,
          allowBlank = _this$props.allowBlank;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = options[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var option = _step.value;

          if (option.value === value) return option;
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (!allowBlank) return options[0];
    };

    _this.inputElement = (0, _createRef2.default)();

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;


    _this.state = {
      composedTheme: (0, _utils.composeTheme)((0, _utils.addThemeId)(theme || context.theme, themeId), (0, _utils.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      isOpen: false
    };
    return _this;
  }

  _createClass(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.autoFocus) {
        return this.focus();
      }
    }

    // ========= PUBLIC SKIN API =========

    // Focus the component - toggle dropdown

  }, {
    key: 'render',
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _props = this.props,
          SelectSkin = _props.skin,
          theme = _props.theme,
          themeOverrides = _props.themeOverrides,
          autoFocus = _props.autoFocus,
          context = _props.context,
          allowBlank = _props.allowBlank,
          rest = _objectWithoutProperties(_props, ['skin', 'theme', 'themeOverrides', 'autoFocus', 'context', 'allowBlank']);

      return _react2.default.createElement(SelectSkin, _extends({
        isOpen: this.state.isOpen,
        inputRef: this.inputElement,
        theme: this.state.composedTheme,
        getSelectedOption: this.getSelectedOption,
        handleInputClick: this.handleInputClick,
        handleChange: this.handleChange,
        toggleOpen: this.toggleOpen
      }, rest));
    }
  }]);

  return Select;
}(_react.Component);

Select.defaultProps = {
  allowBlank: true,
  autoFocus: false,
  isOpeningUpward: false,
  theme: null,
  themeOverrides: {},
  themeId: _API.IDENTIFIERS.SELECT,
  value: ''
};
exports.default = (0, _withTheme.withTheme)(Select);
//# sourceMappingURL=Select.js.map