'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slice2 = require('lodash/slice');

var _slice3 = _interopRequireDefault(_slice2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

// external libraries


// components


// skins


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _components = require('../../components');

var _2 = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (props) {
  var label = props.label,
      error = props.error;

  var theme = props.theme[props.themeId];
  var formfieldProps = { label: label, error: error };

  var filteredAndLimitedOptions = (0, _slice3.default)(props.filteredOptions, 0, props.maxVisibleOptions);

  // show placeholder only if no maximum selections declared or maximum not reached
  var canMoreOptionsBeSelected = props.selectedOptions.length < props.maxSelections;

  var placeholder = !props.maxSelections || canMoreOptionsBeSelected ? props.placeholder : '';

  var renderSelectedOptions = function renderSelectedOptions() {
    // check if the user passed a renderSelections function
    if (props.selectedOptions && props.renderSelections) {
      // call custom renderSelections function
      return props.renderSelections(props.getSelectionProps);
    } else if (props.selectedOptions && !props.renderSelections) {
      // render default skin
      return props.selectedOptions.map(function (selectedOption, index) {
        return _react2.default.createElement(
          'span',
          { className: theme.selectedWordBox, key: index },
          _react2.default.createElement(
            'span',
            { className: theme.selectedWordValue },
            selectedOption,
            _react2.default.createElement(
              'span',
              {
                role: 'presentation',
                'aria-hidden': true,
                className: theme.selectedWordRemoveButton,
                onClick: props.removeOption.bind(null, index)
              },
              '\xD7'
            )
          )
        );
      });
    }
    return null;
  };

  // selected words and input for entering a new one
  var autocompleteContent = _react2.default.createElement(
    'div',
    { className: theme.selectedWords },
    renderSelectedOptions(),
    _react2.default.createElement('input', {
      ref: props.inputRef,
      placeholder: placeholder,
      value: props.inputValue,
      onChange: props.handleInputChange,
      onKeyDown: props.onKeyDown
    })
  );

  return _react2.default.createElement(
    'div',
    { className: props.className, ref: props.rootRef },
    _react2.default.createElement(_components.FormField, _extends({
      error: props.error,
      label: props.label,
      skin: _2.FormFieldSkin,
      render: function render() {
        return _react2.default.createElement(
          'div',
          {
            role: 'presentation',
            'aria-hidden': true,
            className: theme.autocompleteWrapper,
            onClick: props.handleAutocompleteClick
          },
          _react2.default.createElement(
            'div',
            {
              className: (0, _classnames2.default)([theme.autocompleteContent, props.isOpen ? theme.opened : null, props.selectedOptions.length ? theme.hasSelectedWords : null, props.error ? theme.errored : null]),
              ref: props.suggestionsRef
            },
            autocompleteContent
          ),
          _react2.default.createElement(_components.Options, {
            isOpen: props.isOpen,
            isOpeningUpward: props.isOpeningUpward,
            noResults: !props.filteredOptions.length,
            onChange: props.handleChange,
            onClose: props.closeOptions,
            options: filteredAndLimitedOptions,
            resetOnClose: true,
            selectedOptions: props.selectedOptions,
            skin: _2.OptionsSkin,
            render: props.renderOptions
          })
        );
      }
    }, formfieldProps))
  );
};
//# sourceMappingURL=AutocompleteSkin.js.map