'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

// external libraries


// components


// skins


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _components = require('../../components');

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (props) {
  var getOptionProps = props.getOptionProps,
      render = props.render,
      theme = props.theme,
      themeId = props.themeId,
      options = props.options,
      optionRenderer = props.optionRenderer,
      isOpeningUpward = props.isOpeningUpward,
      isOpen = props.isOpen,
      noResults = props.noResults,
      noResultsMessage = props.noResultsMessage,
      getHighlightedOptionIndex = props.getHighlightedOptionIndex,
      isHighlightedOption = props.isHighlightedOption,
      isSelectedOption = props.isSelectedOption,
      handleClickOnOption = props.handleClickOnOption,
      setHighlightedOptionIndex = props.setHighlightedOptionIndex,
      optionsRef = props.optionsRef;


  var highlightedOptionIndex = getHighlightedOptionIndex();
  var isFirstOptionHighlighted = highlightedOptionIndex === 0;
  var sortedOptions = isOpeningUpward ? options.slice().reverse() : options;

  var checkOptionRenderer = function checkOptionRenderer(option) {
    if (optionRenderer) {
      return optionRenderer(option);
    } else if ((typeof option === 'undefined' ? 'undefined' : _typeof(option)) === 'object') {
      return _react2.default.createElement(
        'span',
        { className: theme[themeId].label },
        option.label
      );
    }
    return option;
  };

  var renderOptions = function renderOptions() {
    // check for user's custom render function
    // if Options is being rendered via Autocomplete,
    // the value of props.render is renderOptions passed down from AutocompleteSkin
    if (!noResults && render) {
      // call user's custom render function
      return render(getOptionProps);
    } else if (!noResults && !render) {
      // render default simple skin
      return sortedOptions.map(function (option, index) {
        // saves reference to func in memory, prevents unwanted rerenders
        // anonymous funcs in event handlers are reassigned in memory each render cycle
        var boundSetHighlightedOptionIndex = setHighlightedOptionIndex.bind(null, index);
        var boundHandleClickOnOption = handleClickOnOption.bind(null, option);
        return _react2.default.createElement(
          'li',
          {
            role: 'presentation',
            'aria-hidden': true,
            key: index,
            className: (0, _classnames2.default)([theme[themeId].option, isHighlightedOption(index) ? theme[themeId].highlightedOption : null, isSelectedOption(index) ? theme[themeId].selectedOption : null, option.isDisabled ? theme[themeId].disabledOption : null]),
            onClick: boundHandleClickOnOption,
            onMouseEnter: boundSetHighlightedOptionIndex
          },
          checkOptionRenderer(option)
        );
      });
    }
    // render no results message
    return _react2.default.createElement(
      'li',
      { className: theme[themeId].option },
      noResultsMessage
    );
  };

  return _react2.default.createElement(
    'div',
    { ref: optionsRef },
    _react2.default.createElement(
      _components.Bubble,
      {
        className: (0, _classnames2.default)([theme[themeId].options, isOpen ? theme[themeId].isOpen : null, isOpeningUpward ? theme[themeId].openUpward : null, isFirstOptionHighlighted && !noResults ? theme[themeId].firstOptionHighlighted : null]),
        isTransparent: false,
        skin: _.BubbleSkin,
        isOpeningUpward: isOpeningUpward,
        isHidden: !isOpen,
        isFloating: true
      },
      _react2.default.createElement(
        'ul',
        { className: theme[themeId].ul },
        renderOptions()
      )
    )
  );
};
//# sourceMappingURL=OptionsSkin.js.map