'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _components = require('../../components');

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// components
exports.default = function (props) {
  var selectedOption = props.getSelectedOption();
  var inputValue = selectedOption ? selectedOption.label : '';
  var theme = props.theme,
      themeId = props.themeId;

  return _react2.default.createElement(
    'div',
    {
      className: (0, _classnames2.default)([props.className, theme[themeId].select, props.isOpen ? theme[themeId].isOpen : null, props.isOpeningUpward ? theme[themeId].openUpward : null])
    },
    _react2.default.createElement(
      'div',
      { className: theme[themeId].selectInput },
      _react2.default.createElement(_components.Input, {
        skin: _.InputSkin,
        theme: theme,
        inputRef: props.inputRef,
        label: props.label,
        value: inputValue,
        onClick: props.handleInputClick,
        placeholder: props.placeholder,
        error: props.error,
        readOnly: true
      })
    ),
    _react2.default.createElement(_components.Options, {
      skin: _.OptionsSkin,
      theme: theme,
      isOpen: props.isOpen,
      options: props.options,
      isOpeningUpward: props.isOpeningUpward,
      onChange: props.handleChange,
      optionRenderer: props.optionRenderer,
      onClose: props.toggleOpen,
      selectedOption: selectedOption,
      noResults: !props.options.length
    })
  );
};

// skins


// external libraries
//# sourceMappingURL=SelectSkin.js.map