'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThemeContext = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactContext = require('create-react-context');

var _createReactContext2 = _interopRequireDefault(_createReactContext);

var _simple = require('./simple');

var _simple2 = _interopRequireDefault(_simple);

var _API = require('./API');

var _API2 = _interopRequireDefault(_API);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// check for createContext method on React


// components that are NOT directly nested within a ThemeProvider
// can access simple theme as "this.props.context.theme",
// same goes for "this.props.context.ROOT_THEME_API"
// if the user passes ThemeProvider a theme and/or ROOT_THEME_API,
// these default values are overwritten

var createContext = void 0;
if (_react2.default.createContext) {
  // use React.createContext
  createContext = _react2.default.createContext;
} else {
  // use create-react-context polyfill
  createContext = _createReactContext2.default;
}

var ThemeContext = exports.ThemeContext = createContext({
  theme: _simple2.default,
  ROOT_THEME_API: _API2.default
});
//# sourceMappingURL=ThemeContext.js.map