'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withTheme = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _forwardRef = require('create-react-ref/lib/forwardRef');

var _forwardRef2 = _interopRequireDefault(_forwardRef);

var _ThemeContext = require('./ThemeContext');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// withTheme is a HOC that takes a Component as a parameter
// and returns that Component wrapped within ThemeContext.Consumer.
// Any additional props and refs are forwarded to the returned Component.
var withTheme = exports.withTheme = function withTheme(Component) {
  return (0, _forwardRef2.default)(function (props, ref) {
    return _react2.default.createElement(
      _ThemeContext.ThemeContext.Consumer,
      null,
      function (context) {
        return _react2.default.createElement(Component, _extends({ context: context, ref: ref }, props));
      }
    );
  });
};
//# sourceMappingURL=withTheme.js.map