'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.removeEventListenerOnTransitionEnded = exports.addEventListenerOnTransitionEnded = exports.targetIsDescendant = exports.removeEventsFromDocument = exports.addEventsToDocument = exports.pauseEvent = exports.getTouchPosition = exports.getMousePosition = exports.addThemeId = exports.composeTheme = exports.composeFunctions = exports.pickDOMProps = undefined;

var _props = require('./props');

var _props2 = _interopRequireDefault(_props);

var _themes = require('./themes');

var _themes2 = _interopRequireDefault(_themes);

var _events = require('./events');

var _events2 = _interopRequireDefault(_events);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// named exports for props utility functions
var pickDOMProps = _props2.default.pickDOMProps,
    composeFunctions = _props2.default.composeFunctions;

// named exports for theme utility functions

exports.pickDOMProps = pickDOMProps;
exports.composeFunctions = composeFunctions;
var composeTheme = _themes2.default.composeTheme,
    addThemeId = _themes2.default.addThemeId;

// named exports for event utility functions

exports.composeTheme = composeTheme;
exports.addThemeId = addThemeId;
var getMousePosition = _events2.default.getMousePosition,
    getTouchPosition = _events2.default.getTouchPosition,
    pauseEvent = _events2.default.pauseEvent,
    addEventsToDocument = _events2.default.addEventsToDocument,
    removeEventsFromDocument = _events2.default.removeEventsFromDocument,
    targetIsDescendant = _events2.default.targetIsDescendant,
    addEventListenerOnTransitionEnded = _events2.default.addEventListenerOnTransitionEnded,
    removeEventListenerOnTransitionEnded = _events2.default.removeEventListenerOnTransitionEnded;

// exports default object containing all utility functions
// in the instance of wanting all of them imported at once

exports.getMousePosition = getMousePosition;
exports.getTouchPosition = getTouchPosition;
exports.pauseEvent = pauseEvent;
exports.addEventsToDocument = addEventsToDocument;
exports.removeEventsFromDocument = removeEventsFromDocument;
exports.targetIsDescendant = targetIsDescendant;
exports.addEventListenerOnTransitionEnded = addEventListenerOnTransitionEnded;
exports.removeEventListenerOnTransitionEnded = removeEventListenerOnTransitionEnded;
exports.default = {
  pickDOMProps: pickDOMProps,
  composeTheme: composeTheme,
  addThemeId: addThemeId,
  getMousePosition: getMousePosition,
  getTouchPosition: getTouchPosition,
  pauseEvent: pauseEvent,
  addEventsToDocument: addEventsToDocument,
  removeEventsFromDocument: removeEventsFromDocument,
  targetIsDescendant: targetIsDescendant,
  addEventListenerOnTransitionEnded: addEventListenerOnTransitionEnded,
  removeEventListenerOnTransitionEnded: removeEventListenerOnTransitionEnded,
  composeFunctions: composeFunctions
};
//# sourceMappingURL=index.js.map